# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/api/02-vis.ipynb.

# %% auto 0
__all__ = ['D2API', 'dot2graph', 'd22graph']

# %% ../nbs/api/02-vis.ipynb 4
from IPython.display import SVG
import graphviz as gv  

class D2API:
    @staticmethod
    def create_svg(
        d2: str, 
        app: str = 'd2', # requiring installing d2 first
        ) -> SVG:
        """ Draw svg via kroki online api or d2 engine.
        
        See d2 installation [doc](https://d2lang.com/tour/install/).
        """
        if app == 'd2':
            import subprocess
            d2_fname = "_temp.d2"
            with open(d2_fname, 'w', encoding='utf-8') as f:
                f.write(d2)
            output = subprocess.getoutput(f'd2 {d2_fname} - ')
            output = output.rsplit('\n', 1)[0]
            res = SVG(output)
        elif app == 'kroki':
            from kroki import diagram_image
            # slow
            res = diagram_image(d2, diagram_type='d2', output_format='svg')
        return res



# %% ../nbs/api/02-vis.ipynb 6
def dot2graph(dot, **kw): 
    gv_g = gv.Digraph()
    gv_g.body += str(gv.Source(dot)).splitlines()[1: -1]  # read dot string
    gv_g.attr(rankdir='LR', **kw)
    gv_g.node_attr = {'fontname': 'fira code retina', **kw}
    return gv_g


# %% ../nbs/api/02-vis.ipynb 7
def d22graph(d2_string, app='kroki'): 
    return D2API.create_svg(d2_string, app=app)

